//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "OglTestForm.h"
#include "ObjDetails.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma resource "*.dfm"
TObjectDetails *ObjectDetails;
//---------------------------------------------------------------------------
__fastcall TObjectDetails::TObjectDetails(TComponent* Owner)
    : TForm(Owner)
{
    noclick=false;
}
//---------------------------------------------------------------------------
void __fastcall TObjectDetails::FormHide(TObject *Sender)
{
    Form1->ViewDetails->Down = false;
}
//---------------------------------------------------------------------------
void __fastcall TObjectDetails::FormCreate(TObject *Sender)
{
Form1->UpdateTree();
CylinderParams->Min->Element[0] = 0;
CylinderParams->Min->Element[1] = 0;
CylinderParams->Min->Element[2] = 0;
CylinderParams->Max->Element[0] = 10;
CylinderParams->Max->Element[1] = 10;
CylinderParams->Max->Element[2] = 10;
CylinderParams->Value->Element[0] = 1.0;
CylinderParams->Value->Element[1] = 1.0;
CylinderParams->Value->Element[2] = 1.0;

DiskParams->Min->Element[0] = 0;
DiskParams->Min->Element[1] = 0;
DiskParams->Max->Element[0] = 10;
DiskParams->Max->Element[1] = 10;
DiskParams->Value->Element[0] = 1.0;
DiskParams->Value->Element[1] = 1.0;

SpherePage->TabVisible = false;
CylinderPage->TabVisible = false;
DiskPage->TabVisible = false;
QuadPage->TabVisible = false;
}
//---------------------------------------------------------------------------
void __fastcall TObjectDetails::NameChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPart * pP = (TPart *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->Name = Name->Text;
        Form1->ObjectsTree->Selected->Text = pP->FullName;
        }
}
//---------------------------------------------------------------------------
void __fastcall TObjectDetails::PositionChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPart * pP = (TPart *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->PX = Position->Value->X;
        pP->PY = Position->Value->Y;
        pP->PZ = Position->Value->Z;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::RotationVectorChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPart * pP = (TPart *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->RX = RotationVector->Value->X;
        pP->RY = RotationVector->Value->Y;
        pP->RZ = RotationVector->Value->Z;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::ScaleChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPart * pP = (TPart *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->SX = Scale->Value->X;
        pP->SY = Scale->Value->Y;
        pP->SZ = Scale->Value->Z;
        }
}
//---------------------------------------------------------------------------


void __fastcall TObjectDetails::RotationAngleChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPart * pP = (TPart *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->RotationAngle = RotationAngle->Value->Degrees;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::SphereParamsChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartSphere * pP = (TPartSphere *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->Slices = SphereSlices->Value;
        pP->Stacks = SphereStacks->Value;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::CylinderParamsChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartCylinder * pP = (TPartCylinder *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->Slices = CylinderSlices->Value;
        pP->Stacks = CylinderStacks->Value;
        pP->BaseRadius = CylinderParams->Value->Element[0];
        pP->TopRadius = CylinderParams->Value->Element[1];
        pP->Height = CylinderParams->Value->Element[2];
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::DiskParamsChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartDisk * pP = (TPartDisk *)Form1->ObjectsTree->Selected->Data;
    if (pP)
        {
        pP->Slices = DiskSlices->Value;
        pP->Loops = DiskLoops->Value;
        pP->InnerRadius = DiskParams->Value->Element[0];
        pP->OuterRadius = DiskParams->Value->Element[1];
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::RefreshQuadVertex(TObject *Sender)
{
    if (!Form1->ObjectsTree->Selected)
        return;
    TPartQuad * pQuad = (TPartQuad *)Form1->ObjectsTree->Selected->Data;
    Vertex->Value->X = pQuad->X[CurrPoint->Value];
    Vertex->Value->Y = pQuad->Y[CurrPoint->Value];
    Vertex->Value->Z = pQuad->Z[CurrPoint->Value];
    Normal->Value->X = pQuad->NormX[CurrPoint->Value];
    Normal->Value->Y = pQuad->NormY[CurrPoint->Value];
    Normal->Value->Z = pQuad->NormZ[CurrPoint->Value];
}

void __fastcall TObjectDetails::UpdateQuadVertex(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartQuad * pQuad = (TPartQuad *)Form1->ObjectsTree->Selected->Data;
    pQuad->X[CurrPoint->Value] = Vertex->Value->X;
    pQuad->Y[CurrPoint->Value] = Vertex->Value->Y;
    pQuad->Z[CurrPoint->Value] = Vertex->Value->Z;
    pQuad->NormX[CurrPoint->Value] = Normal->Value->X;
    pQuad->NormY[CurrPoint->Value] = Normal->Value->Y;
    pQuad->NormZ[CurrPoint->Value] = Normal->Value->Z;
}

void __fastcall TObjectDetails::CurrPointChange(TObject *Sender)
{
    noclick=true;
    RefreshQuadVertex(Sender);
    noclick = false;
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::VertexChange(TObject *Sender)
{
    UpdateQuadVertex(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::ShapeChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartQuad * pQuad = (TPartQuad *)Form1->ObjectsTree->Selected->Data;
    switch(Shape->ItemIndex)
        {
        case 0:
            pQuad->Shape = GL_POINTS;
            break;
        case 1:
            pQuad->Shape = GL_LINES;
            break;
        case 2:
            pQuad->Shape = GL_LINE_STRIP;
            break;
        case 3:
            pQuad->Shape = GL_LINE_LOOP;
            break;
        case 4:
            pQuad->Shape = GL_TRIANGLES;
            break;
        case 5:
            pQuad->Shape = GL_TRIANGLE_STRIP;
            break;
        case 6:
            pQuad->Shape = GL_TRIANGLE_FAN;
            break;
        case 7:
            pQuad->Shape = GL_QUADS;
            break;
        case 8:
            pQuad->Shape = GL_QUAD_STRIP;
            break;
        case 9:
            pQuad->Shape = GL_POLYGON;
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::NPointsChange(TObject *Sender)
{
    if (noclick || !Form1->ObjectsTree->Selected)
        return;
    TPartQuad * pQuad = (TPartQuad *)Form1->ObjectsTree->Selected->Data;
    String s = NPoints->Text;
    if (s.Length() > 0 && NPoints->Value > 0)
        {
        pQuad->NPoints = NPoints->Value;
        CurrPoint->MaxValue = NPoints->Value-1;
        }
}
//---------------------------------------------------------------------------

void __fastcall TObjectDetails::NormalChange(TObject *Sender)
{
    UpdateQuadVertex(Sender);
}
//---------------------------------------------------------------------------

