//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include <math.h>
#include "OglTestForm.h"
#include "ObjDetails.h"
#include "ab.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma link "Pos3D"
#pragma resource "*.dfm"
TForm1 *Form1;
#define MYCUBE 33
#define MYSPHERE 34
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Angle = 0.0;
    ViewAnimationAngle = 0.0;
    FClipboard = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AnimationClick(TObject *Sender)
{
    gl->Animation = Animation->Down;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::glFrame(TObject *Sender)
{
//    if (AnimateProjection && AnimateProjection->Checked)
//        gl->EyeUp = EyeUp->Value;

    Angle += 2.0;
    if (Angle > 360.0)
        Angle = 0;
    static int fc;
    fc++;
    if (fc > 50)
        {
        fc = 0;
        char mmm[100];
        sprintf(mmm, "%3.2f", gl->Fps);
        Fps->Text = mmm;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProjWidthChange(TObject *Sender)
{
float f = ProjWidth->Position;
gl->ProjectionWidth = f/10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProjHeightChange(TObject *Sender)
{
float f = ProjHeight->Position;
gl->ProjectionHeight = f/10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProjNearChange(TObject *Sender)
{
float f = ProjNear->Position;
gl->ProjectionNear = f/10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProjFarChange(TObject *Sender)
{
float f = ProjFar->Position;
gl->ProjectionFar = f/100;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OrthogonalClick(TObject *Sender)
{
if (Orthogonal->Checked)
    {
    ProjWidth->Visible = true;
    ProjHeight->Visible = true;
    Label2->Visible = true;
    Label3->Visible = true;
    Label18->Visible = false;
    ProjYAngle->Visible = false;
    }
else
    {
    ProjWidth->Visible = false;
    ProjHeight->Visible = false;
    Label2->Visible = false;
    Label3->Visible = false;
    Label18->Visible = true;
    ProjYAngle->Visible = true;
    }
gl->ProjectionOrtho = Orthogonal->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::defineCube()
{
}

void __fastcall TForm1::defineSphere()
{
}

void __fastcall TForm1::glInitRC(TObject *Sender)
{
    glEnable(GL_TEXTURE_2D);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);


    quadric = 0;
    glColor4f(1.0,1.0,1.0,1.0);
    defineCube();
    defineSphere();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CubeSideChange(TObject *Sender)
{
    defineCube();
    gl->Refresh(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CubeXChange(TObject *Sender)
{
    gl->Refresh(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{

for (int i=0; i<MAXBITMAPS; i++)
    {
    char mmm[100];
    sprintf(mmm, "Bitmap %d", i);
    BitmapN->Items->Add(mmm);
    }
BitmapN->ItemIndex = 0;

for (int i= 0; i<MAXLIGHTS; i++)
    {
    char mmm[100];
    sprintf(mmm, "Light%d", i);
    Luci->Items->Add(mmm);
    }
Luci->ItemIndex = 0;
gl->Lights[0]->Enabled = true;
LuciChange(this);

//Image1->Picture->LoadFromFile("coolworld.bmp");

//ImageW->Caption = Image1->Picture->Bitmap->Height;
//ImageH->Caption = Image1->Picture->Bitmap->Width;
//gl->Textures[0] = Image1->Picture;
//gl->Textures[0] = Image1->Picture;
gl->EyePosition = EyePosition->Value;
gl->EyeTarget = EyeTarget->Value;
gl->EyeUp = EyeUp->Value;

}


//---------------------------------------------------------------------------
bool noclick = false;
void __fastcall TForm1::LuciChange(TObject *Sender)
{
    int idx = Luci->ItemIndex;
    noclick=true;
    LuceEnabled->Checked = gl->Lights[idx]->Enabled;
    LucePosition->Value = gl->Lights[idx]->Position;
    LuceAmbient->Value = gl->Lights[idx]->Ambient;
    LuceDiffuse->Value = gl->Lights[idx]->Diffuse;
    LuceSpecular->Value = gl->Lights[idx]->Specular;
    noclick=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetLuci()
{
#ifdef NOOO
    glLoadIdentity();
    for (int i=0; i<MAXLIGHTS; i++)
        {
        if (gl->Lights[i]->Enabled)
            {
            glEnable(GL_LIGHT0+i);
            glLightfv(GL_LIGHT0+i,
                GL_POSITION,
                gl->Lights[i]->Position->Vector());
            glLightfv(GL_LIGHT0+i,
                GL_AMBIENT,
                gl->Lights[i]->Ambient->Vector());
            glLightfv(GL_LIGHT0+i,
                GL_DIFFUSE,
                gl->Lights[i]->Diffuse->Vector());
            glLightfv(GL_LIGHT0+i,
                GL_SPECULAR,
                gl->Lights[i]->Specular->Vector());
            }
        else
            {
            glDisable(GL_LIGHT0+i);
            }
        }
    gl->Refresh(this);
#endif
}

void __fastcall TForm1::UpdateLuce()
{
    if (noclick)
        return;
    int idx = Luci->ItemIndex;
    gl->Lights[idx]->Enabled = LuceEnabled->Checked;
    gl->Lights[idx]->Position->Assign((TPersistent *)LucePosition->Value);
    gl->Lights[idx]->Ambient->Assign((TPersistent *)LuceAmbient->Value);
    gl->Lights[idx]->Diffuse->Assign((TPersistent *)LuceDiffuse->Value);
    gl->Lights[idx]->Specular->Assign((TPersistent *)LuceSpecular->Value);
//    SetLuci();
}

//---------------------------------------------------------------------------


void __fastcall TForm1::LuceEnabledClick(TObject *Sender)
{
    UpdateLuce();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ProjYAngleChange(TObject *Sender)
{
float f = ProjYAngle->Position;
gl->ProjectionYAngle = f/10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SphereRadiusChange(TObject *Sender)
{
    defineSphere();
    gl->Refresh(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
if (OpenDialog1->Execute())
    {
    Image1->Picture->LoadFromFile(OpenDialog1->FileName);
    gl->Textures[BitmapN->ItemIndex] = Image1->Picture;
//    Image1->Picture->Bitmap->Canvas->Font->Color = clRed;
//    Image1->Picture->Bitmap->Canvas->Font->Size = 20;
//    Image1->Picture->Bitmap->Canvas->TextOut(10,10,"Ciao");
    ImageW->Caption = Image1->Picture->Bitmap->Height;
    ImageH->Caption = Image1->Picture->Bitmap->Width;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitmapNChange(TObject *Sender)
{
    Image1->Picture->Assign(gl->Textures[BitmapN->ItemIndex]);
    ImageW->Caption = Image1->Picture->Bitmap->Height;
    ImageH->Caption = Image1->Picture->Bitmap->Width;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::LucePositionChange(TObject *Sender)
{
    if (!noclick)
        UpdateLuce();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CubePositionChange(TObject *Sender)
{
gl->Refresh(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpherePositionChange(TObject *Sender)
{
gl->Refresh(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EyePositionChange(TObject *Sender)
{
    gl->EyePosition = EyePosition->Value;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EyeTargetChange(TObject *Sender)
{
    gl->EyeTarget = EyeTarget->Value;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EyeUpChange(TObject *Sender)
{
    gl->EyeUp = EyeUp->Value;
}
//---------------------------------------------------------------------------

TTreeNode * __fastcall TForm1::AddObject(TTreeNode*Node, TPart * part, bool child)
{
    TTreeNode * pN=0;
    if (child)
        pN =  ObjectsTree->Items->AddChildObject(Node, part->FullName, part);
    else
        pN =  ObjectsTree->Items->AddObject(Node, part->FullName, part);
    pN->Expand(true);
    return pN;
}

void __fastcall TForm1::FillGroup(TTreeNode * pN, TPart * pP)
{
    TPartGroup * pGroup = dynamic_cast<TPartGroup *>(pP);
    if (pGroup)
        {
        for (int i=0; i < pGroup->Parts->Count; i++)
            {
            TPart * pPart = (TPart *)pGroup->Parts->Items[i];
            TTreeNode * pNode = AddObject(pN, pPart, true);
            if (pPart == gl->SuggestedSelection)
                currSel = pNode;
            FillGroup(pNode, pPart);
            }
        }
}

void __fastcall TForm1::UpdateTree()
{
    ObjectsTree->Items->BeginUpdate();
    currSel = 0;
    ObjectsTree->Items->Clear();
    for (int i=0; i < gl->Parts->Count; i++)
        {
        TPart * pPart = (TPart *)gl->Parts->Items[i];
        TTreeNode * pNode = AddObject(ObjectsTree->Selected, pPart);
        if (pPart == gl->SuggestedSelection)
            currSel = pNode;
        FillGroup(pNode, pPart);
        }
    if (currSel)
        Select(currSel);
    else
        {
        if (ObjectsTree->Items->Count > 0)
            Select(ObjectsTree->Items->Item[0]);
        }
    ObjectsTree->Items->EndUpdate();
}

void __fastcall TForm1::Select(TTreeNode* Node)
{
    ObjectDetails->NoClick(true);
    ObjectsTree->Selected = Node;
    TPart * pP = (TPart *)Node->Data;
    if (pP)
        {
        ObjectDetails->FullName->Caption = pP->FullName;
        ObjectDetails->Name->Text = pP->Name;
        ObjectDetails->Position->Value->X = pP->PX;
        ObjectDetails->Position->Value->Y = pP->PY;
        ObjectDetails->Position->Value->Z = pP->PZ;
        ObjectDetails->RotationVector->Value->X = pP->RX;
        ObjectDetails->RotationVector->Value->Y = pP->RY;
        ObjectDetails->RotationVector->Value->Z = pP->RZ;
        ObjectDetails->Scale->Value->X = pP->SX;
        ObjectDetails->Scale->Value->Y = pP->SY;
        ObjectDetails->Scale->Value->Z = pP->SZ;
        ObjectDetails->RotationAngle->Value->Degrees = pP->RotationAngle;

        TPartSphere * pSphere = dynamic_cast<TPartSphere *>(pP);
        ObjectDetails->SpherePage->TabVisible = false;
        if (pSphere)
            {
            ObjectDetails->SpherePage->TabVisible = true;
            ObjectDetails->SphereSlices->Value = pSphere->Slices;
            ObjectDetails->SphereStacks->Value = pSphere->Stacks;
            }

        TPartCylinder * pCylinder = dynamic_cast<TPartCylinder *>(pP);
        ObjectDetails->CylinderPage->TabVisible = false;
        if (pCylinder)
            {
            ObjectDetails->CylinderPage->TabVisible = true;
            ObjectDetails->CylinderSlices->Value = pCylinder->Slices;
            ObjectDetails->CylinderStacks->Value = pCylinder->Stacks;
            ObjectDetails->CylinderParams->Value->Element[0] = pCylinder->BaseRadius;
            ObjectDetails->CylinderParams->Value->Element[1] = pCylinder->TopRadius;
            ObjectDetails->CylinderParams->Value->Element[2] = pCylinder->Height;
            }

        TPartDisk * pDisk = dynamic_cast<TPartDisk *>(pP);
        ObjectDetails->DiskPage->TabVisible = false;
        if (pDisk)
            {
            ObjectDetails->DiskPage->TabVisible = true;
            ObjectDetails->DiskSlices->Value = pDisk->Slices;
            ObjectDetails->DiskLoops->Value = pDisk->Loops;
            ObjectDetails->DiskParams->Value->Element[0] = pDisk->InnerRadius;
            ObjectDetails->DiskParams->Value->Element[1] = pDisk->OuterRadius;
            }

        TPartQuad * pQuad = dynamic_cast<TPartQuad *>(pP);
        ObjectDetails->QuadPage->TabVisible = false;
        if (pQuad)
            {
            ObjectDetails->QuadPage->TabVisible = true;
            int idx = -1;
            switch(pQuad->Shape)
                {
                case GL_POINTS:
                    idx = 0;
                    break;
                case GL_LINES:
                    idx = 1;
                    break;
                case GL_LINE_STRIP:
                    idx = 2;
                    break;
                case GL_LINE_LOOP:
                    idx = 3;
                    break;
                case GL_TRIANGLES:
                    idx = 4;
                    break;
                case GL_TRIANGLE_STRIP:
                    idx = 5;
                    break;
                case GL_TRIANGLE_FAN:
                    idx = 6;
                    break;
                case GL_QUADS:
                    idx = 7;
                    break;
                case GL_QUAD_STRIP:
                    idx = 8;
                    break;
                case GL_POLYGON:
                    idx = 0;
                    break;
                }
            ObjectDetails->Shape->ItemIndex = idx;
            ObjectDetails->NPoints->Value = pQuad->NPoints;
            ObjectDetails->CurrPoint->MaxValue = pQuad->NPoints - 1;
            ObjectDetails->CurrPoint->Value = 0;
            ObjectDetails->Vertex->Value->X = pQuad->X[0];
            ObjectDetails->Vertex->Value->Y = pQuad->Y[0];
            ObjectDetails->Vertex->Value->Z = pQuad->Z[0];
            ObjectDetails->Normal->Value->X = pQuad->NormX[0];
            ObjectDetails->Normal->Value->Y = pQuad->NormY[0];
            ObjectDetails->Normal->Value->Z = pQuad->NormZ[0];
            }

        }
    else
        ObjectDetails->FullName->Caption = "";
    ObjectDetails->NoClick(false);
    ObjectDetails->Update();
}

void __fastcall TForm1::ViewDetailsClick(TObject *Sender)
{
ObjectDetails->Visible = ViewDetails->Down;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ObjectsTreeChange(TObject *Sender, TTreeNode *Node)
{
    Select(Node);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddCubeClick(TObject *Sender)
{
    gl->AddCube((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::glListChanged(TObject *Sender)
{
    UpdateTree();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
LucePosition->Value->W = 0.0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LuceAmbientChange(TObject *Sender)
{
    UpdateLuce();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LuceDiffuseChange(TObject *Sender)
{
    UpdateLuce();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LuceSpecularChange(TObject *Sender)
{
    UpdateLuce();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
    gl->AddSphere((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
    if (ObjectsTree->Selected != NULL)
        {
        gl->DeleteObject((TPart *)ObjectsTree->Selected->Data);
        }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::glSetProjection(TObject *Sender)
{
    if (Animation && AnimateProjection && Animation->Down && AnimateProjection->Checked)
        {
        ViewAnimationAngle += 2.0;
        if (ViewAnimationAngle > 360.0)
            ViewAnimationAngle = 0;
        glRotatef(ViewAnimationAngle,
                    EyeUp->Value->X,
                    EyeUp->Value->Y,
                    EyeUp->Value->Z);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
    gl->AddCylinder((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
    gl->AddDisk((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
    if (SaveDialog1->Execute())
        {
        gl->SaveTo(SaveDialog1->FileName);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
    if (OpenDialog2->Execute())
        {
        gl->LoadFrom(OpenDialog2->FileName);
        EyePosition->Value = gl->EyePosition;
        EyeTarget->Value = gl->EyeTarget;
        EyeUp->Value = gl->EyeUp;
        ProjWidth->Position = (int)(gl->ProjectionWidth * 10);
        ProjHeight->Position = (int)(gl->ProjectionHeight * 10);
        ProjNear->Position = (int)(gl->ProjectionNear * 10);
        ProjFar->Position = (int)(gl->ProjectionFar * 100);
        ProjYAngle->Position = (int)(gl->ProjectionYAngle * 10);
        LuciChange(this);
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{
    gl->AddGroup((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetClipboard(TPart * value)
{
    if (FClipboard)
        delete FClipboard;
    FClipboard = value;
}

void __fastcall TForm1::Copy1Click(TObject *Sender)
{
    TPart * pp = (TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0);
    if (pp)
        {
        Clipboard = pp->Clone();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Paste1Click(TObject *Sender)
{
    TPart * pp = (TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0);
    if (Clipboard)
        gl->Paste(pp, Clipboard->Clone());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clear1Click(TObject *Sender)
{
    if (ObjectsTree->Selected != NULL)
        {
        gl->DeleteObject((TPart *)ObjectsTree->Selected->Data);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenu1Popup(TObject *Sender)
{
    if (ObjectsTree->Selected != NULL)
        {
        Copy1->Enabled=true;
        Clear1->Enabled=true;
        }
    else
        {
        Copy1->Enabled=false;
        Clear1->Enabled=false;
        }
    Paste1->Enabled = (Clipboard != 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
    gl->AddQuad((TPart *)(ObjectsTree->Selected ? ObjectsTree->Selected->Data : 0));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
About->ShowModal();    
}
//---------------------------------------------------------------------------

