//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include "OpenGl.h"
#pragma package(smart_init)
#include <typeinfo.h>
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TFloatEdit *)
{
    new TFloatEdit(NULL);
}

static inline void ValidCtrCheck(TPos3D *)
{
    new TPos3D(NULL);
}
//---------------------------------------------------------------------------
__fastcall TPos3D::TPos3D(TComponent* Owner)
    : TFloatEdit(Owner)
{
    if (FValue)
        delete FValue;
    FValue = new T3DVector();
    if (FMin)
        delete FMin;
    FMin = new T3DVector();
    if (FMax)
        delete FMax;
    FMax = new T3DVector();

    FMax->Element[0] = 10;
    FMax->Element[1] = 10;
    FMax->Element[2] = 10;
    FMax->Element[3] = 10;
    FMin->Element[0] = -10;
    FMin->Element[1] = -10;
    FMin->Element[2] = -10;
    FMin->Element[3] = -10;
    FValue->OnChange = ValueChanged;
    FMin->OnChange = ValueChanged;
    FMax->OnChange = ValueChanged;

    Labels->Strings[0] = "X";
    Labels->Strings[1] = "  Y";
    Labels->Strings[2] = "  Z";
    Labels->Strings[3] = "  W";
}

__fastcall TColorEdit::TColorEdit(TComponent* Owner)
    : TFloatEdit(Owner)
{
    if (FValue)
        delete FValue;
    FValue = new TColorVector();
    if (FMin)
        delete FMin;
    FMin = new TColorVector();
    if (FMax)
        delete FMax;
    FMax = new TColorVector();

    FMax->Element[0] = 10;
    FMax->Element[1] = 10;
    FMax->Element[2] = 10;
    FMax->Element[3] = 10;
    FMin->Element[0] = 0;
    FMin->Element[1] = 0;
    FMin->Element[2] = 0;
    FMin->Element[3] = 0;
    FValue->OnChange = ValueChanged;
    FMin->OnChange = ValueChanged;
    FMax->OnChange = ValueChanged;

    Labels->Strings[0] = "R";
    Labels->Strings[1] = "  G";
    Labels->Strings[2] = "  B";
    Labels->Strings[3] = "  A";
}

__fastcall TAngleEdit::TAngleEdit(TComponent* Owner)
    : TFloatEdit(Owner)
{
    if (FValue)
        delete FValue;
    FValue = new TAngle();
    if (FMin)
        delete FMin;
    FMin = new TAngle();
    if (FMax)
        delete FMax;
    FMax = new TAngle();

    FMax->Element[0] = 360.0;
    FMin->Element[0] = 0;
    FValue->OnChange = ValueChanged;
    FMin->OnChange = ValueChanged;
    FMax->OnChange = ValueChanged;

    Labels->Strings[0] = "Angle";
    NValues = 1;
}

__fastcall TFloatEdit::TFloatEdit(TComponent* Owner)
    : TPanel(Owner)
{
    FNValues = 3;
    FDecDigits = 2;
    FLabels = new TStringList();
    FLabels->Add("Element0");
    FLabels->Add("Element1");
    FLabels->Add("Element2");
    FLabels->Add("Element3");
    FLabels->OnChange = SetLabelCaptions;
    FValue = new TFloatVector();
    FMin = new TFloatVector();
    FMax = new TFloatVector();
    FMax->Element[0] = 10;
    FMax->Element[1] = 10;
    FMax->Element[2] = 10;
    FMax->Element[3] = 10;
    FMin->Element[0] = -10;
    FMin->Element[1] = -10;
    FMin->Element[2] = -10;
    FMin->Element[3] = -10;
    FValue->OnChange = ValueChanged;
    FMin->OnChange = ValueChanged;
    FMax->OnChange = ValueChanged;
    topPanel = new TPanel(this);
    xEdit = new TLabel(this);
    xEdit->Tag = 0;
    yEdit = new TLabel(this);
    yEdit->Tag = 1;
    zEdit = new TLabel(this);
    zEdit->Tag = 2;
    wEdit = new TLabel(this);
    wEdit->Tag = 3;
    scroll = new TScrollBar(this);
    CurrEdit=xEdit;
    scroll->OnChange = ScrollChange;
    scroll->LargeChange = 100;
    xEdit->OnClick = EditClick;
    yEdit->OnClick = EditClick;
    zEdit->OnClick = EditClick;
    wEdit->OnClick = EditClick;
    SetLabelCaptions(this);

    topPanel->Parent = this;
    topPanel->BevelOuter=bvNone;
    xEdit->Parent=topPanel;
    yEdit->Parent=topPanel;
    zEdit->Parent=topPanel;
    wEdit->Parent=topPanel;
    topPanel->Height=18;
    topPanel->Align = alTop;
    scroll->Parent = this;
    scroll->Align = alClient;
    scroll->Height = 10;
    scroll->Top = 14;
    SetNValues(3);
    ReSizeFields();
    RefreshCurrent();
}

void __fastcall TFloatEdit::SetLabels(TStringList * value)
{
    FLabels->Assign(value);
}

void __fastcall TFloatEdit::SetLabelCaptions(TObject *Sender)
{
    if (Labels->Count>0)
        xEdit->Caption = Labels->Strings[0] + "=0.0";
    if (Labels->Count>1)
        yEdit->Caption = Labels->Strings[1] + "=0.0";
    if (Labels->Count>2)
        zEdit->Caption = Labels->Strings[2] + "=0.0";
    if (Labels->Count>3)
        wEdit->Caption = Labels->Strings[3] + "=0.0";
}

void __fastcall TFloatEdit::ReSizeFields(void)
{
    xEdit->Left = 1;
    xEdit->Align=alLeft;
    xEdit->Top = 1;
    xEdit->Height = 16;
    yEdit->Left = 100;
    yEdit->Align=alLeft;
    yEdit->Top = 1;
    yEdit->Height = 16;
    zEdit->Left = 200;
    zEdit->Align=alLeft;
    zEdit->Top = 1;
    zEdit->Height = 16;
    wEdit->Left = 300;
    wEdit->Align=alLeft;
    wEdit->Top = 1;
    wEdit->Height = 16;
}

void __fastcall TFloatEdit::Loaded(void)
{
    ReSizeFields();
    RefreshCurrent();
    ValueChanged(this);
}

//---------------------------------------------------------------------------
#ifdef NOO
namespace Pos3d
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[4] =
            {
            __classid(TFloatEdit),
            __classid(TPos3D),
            __classid(TColorEdit),
            __classid(TAngleEdit)
            };
        RegisterComponents("3D", classes, 3);
    }
}
#endif
//---------------------------------------------------------------------------
void __fastcall TFloatEdit::RefreshCurrent()
{
    RefreshField(CurrEdit->Tag);
}

void __fastcall TFloatEdit::EditClick(TObject *Sender)
{
    CurrEdit = (TLabel *)Sender;
    RefreshCurrent();
}

void __fastcall TFloatEdit::ScrollChange(TObject *Sender)
{
    double v = scroll->Position;
    v /= 1000;
    FValue->Element[CurrEdit->Tag] = v;
    RefreshCurrent();
    if (OnChange)
        OnChange(this);
}

void __fastcall TFloatEdit::RefreshField(int n)
{
    xEdit->Color = clBtnFace;
    yEdit->Color = clBtnFace;
    zEdit->Color = clBtnFace;
    wEdit->Color = clBtnFace;
    CurrEdit->Color = clYellow;
    char mmm[100];
    int minval = 0;
    int maxval = 0;
    double val = 0;
    char fs[20];
    if (n < FNValues)
        {
        sprintf(fs,"%%s=%%5.%df", FDecDigits);
        sprintf(mmm, fs, Labels->Strings[n].c_str(),FValue->Element[n]);
        }
    else
        mmm[0] = 0;

    switch(n)
        {
        case 0:
            xEdit->Caption = mmm;
            if (CurrEdit->Tag == n)
                {
                xEdit->Color = clYellow;
                }
            else
                xEdit->Color = clBtnFace;
            break;
        case 1:
            yEdit->Caption = mmm;
            if (CurrEdit->Tag == n)
                {
                yEdit->Color = clYellow;
                }
            else
                yEdit->Color = clBtnFace;
            break;
        case 2:
            zEdit->Caption = mmm;
            if (CurrEdit->Tag == n)
                {
                zEdit->Color = clYellow;
                }
            else
                zEdit->Color = clBtnFace;
            break;
        case 3:
            wEdit->Caption = mmm;
            if (CurrEdit->Tag == n)
                {
                wEdit->Color = clYellow;
                }
            else
                wEdit->Color = clBtnFace;
            break;
        }
        if (CurrEdit->Tag == n)
            {
            minval = FMin->Element[n];
            maxval = FMax->Element[n];
            val = FValue->Element[n];
            scroll->Min = minval*1000;
            scroll->Max = maxval*1000;
            val *= 1000;
            scroll->Position = (int)val;
            }
}

void __fastcall TFloatEdit::ValueChanged(TObject *Sender)
{
    RefreshField(0);
    RefreshField(1);
    RefreshField(2);
    RefreshField(3);
}

void __fastcall TFloatEdit::SetValue(TFloatVector * Value)
{
    String s = typeid(Value).name();
    FValue->Assign(Value);
    ValueChanged(this);
}

void __fastcall TFloatEdit::SetMin(TFloatVector * Value)
{
    FMin->Assign((TPersistent *)Value);
    ValueChanged(this);
}

void __fastcall TFloatEdit::SetMax(TFloatVector * Value)
{
    FMax->Assign((TPersistent *)Value);
    ValueChanged(this);
}

void __fastcall TFloatEdit::SetDecDigits(int n)
{
    FDecDigits = n;
    ValueChanged(this);
}

void __fastcall TFloatEdit::SetNValues(int n)
{
    FNValues = n;
    xEdit->Visible = (n>0);
    yEdit->Visible = (n>1);
    zEdit->Visible = (n>2);
    wEdit->Visible = (n>3);
}


// TFloatVector

void __fastcall TFloatVector::Assign(TPersistent * Value)
{
#ifdef NON_FUNZIONA
    X = dynamic_cast<TFloatVector *>(Value)->X;
    Y = dynamic_cast<TFloatVector *>(Value)->Y;
    Z = dynamic_cast<TFloatVector *>(Value)->Z;
    W = dynamic_cast<TFloatVector *>(Value)->W;
#endif
    v[0] = ((TFloatVector *)Value)->v[0];
    v[1] = ((TFloatVector *)Value)->v[1];
    v[2] = ((TFloatVector *)Value)->v[2];
    v[3] = ((TFloatVector *)Value)->v[3];
    Changed();
}


void __fastcall TFloatVector::Changed()
{
    if (OnChange)
        OnChange(this);
}

void __fastcall TFloatVector::SetElement(int n, float AX)
    {
    v[n] = AX;
    Changed();
    }

float __fastcall TFloatVector::GetElement(int n)
{
    return (n < 0 || n > 3) ? 0.0 : v[n];
}


void __fastcall T3DVector::SetX(float value)
{
    Element[0] = value;
}

void __fastcall T3DVector::SetY(float value)
{
    Element[1] = value;
}

void __fastcall T3DVector::SetZ(float value)
{
    Element[2] = value;
}

void __fastcall T3DVector::SetW(float value)
{
    Element[3] = value;
}

float __fastcall T3DVector::GetX()
{
    return  Element[0];
}

float __fastcall T3DVector::GetY()
{
    return  Element[1];
}

float __fastcall T3DVector::GetZ()
{
    return  Element[2];
}

float __fastcall T3DVector::GetW()
{
    return  Element[3];
}


void __fastcall TColorVector::SetR(float value)
{
    Element[0] = value;
}

void __fastcall TColorVector::SetG(float value)
{
    Element[1] = value;
}

void __fastcall TColorVector::SetB(float value)
{
    Element[2] = value;
}

void __fastcall TColorVector::SetA(float value)
{
    Element[3] = value;
}

float __fastcall TColorVector::GetR()
{
    return  Element[0];
}

float __fastcall TColorVector::GetG()
{
    return  Element[1];
}

float __fastcall TColorVector::GetB()
{
    return  Element[2];
}

float __fastcall TColorVector::GetA()
{
    return  Element[3];
}

void __fastcall TAngle::SetDegrees(float value)
{
    Element[0] = value;
}

float __fastcall TAngle::GetDegrees()
{
    return  Element[0];
}


///////////////////////////////////////files
bool TFloatVector::SaveTo(TSceneFile & sf)
{
    sf.writeFloat(v[0]);
    sf.writeFloat(v[1]);
    sf.writeFloat(v[2]);
    sf.writeFloat(v[3]);
    return sf.OK();
}

bool TFloatVector::LoadFrom(int ver, TSceneFile & sf, float def0, float def1, float def2, float def3)
{
    sf.readFloat(ver, v[0], def0);
    sf.readFloat(ver, v[1], def1);
    sf.readFloat(ver, v[2], def2);
    sf.readFloat(ver, v[3], def3);
    return sf.OK();
}


